LeetCode 0136 Single Number

Given a non-empty array of integers, every element appears twice except for one. Find that single one.
Note: Your algorithm should have a linear runtime complexity. Could you implement it without using extra memory?

Example 1:

Input: [2,2,1]
Output: 1
Example 2:

Input: [4,1,2,1,2]
Output: 4

思路1

  1. 遍历 nums 中每一个元素
  2. 查找哈希表中是否出现过该元素
  3. 如果没出现过,插入哈希表;否则移除对应的元素
  4. 最后剩下来的一个就是最后结果

时间复杂度为 O ( N ) O( N ) O(N) 空间复杂度为 O ( N ) O(N) O(N)

代码1

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        unordered_set<int> s;
        for(int i = 0; i < nums.size(); i++)
        {
            if(s.count(nums[i]) <= 0)
                s.insert(nums[i]);
            else
                s.erase(nums[i]);
        }
        return *(s.begin());
    }
};

思路2

先排序,每次两个一次进行遍历,如果当前元素和后面一个元素相同,则继续;如果不同则即为所求(因为两个相等的必连在一起)。需要注意如果是最后一个元素的情况,此时取最后一个元素后面的一个会越界(因此约束遍历范围 s i z e − 1 size-1 size1 ),遍历完仍然没有返回的这个元素就是向量最后一个元素。

总体时间复杂度为 O ( N l o n g N ) O(NlongN) O(NlongN),空间复杂度为 O ( 1 ) O( 1 ) O(1)

代码2

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        sort(nums.begin(), nums.end());
        for(int i = 0; i < nums.size()-1; i += 2)
        {
            if(nums[i] != nums[i+1])
                return nums[i];
        }
        return nums[nums.size()-1];
    }
};

思路3 异或

逐个元素异或剩下来的就是所求 A^B^A=B

因为异或运算是同时满足交换律和结合律的,同一个出现两次的数据会被清除,仅仅只会剩下最后一个出现一次的数据

遍历一遍时间复杂度为 O ( N ) O( N ) O(N), 空间复杂度为 O ( 1 ) O(1) O(1)

代码3

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        for(int i = 1; i < nums.size(); i++)
            nums[i] ^= nums[i-1];
        return nums[nums.size()-1];
    }
};
class Solution {
public:
    int singleNumber(vector<int>& nums) {
        return std::accumulate(nums.begin(), nums.end(), 0, [](int a, int b) {return a ^ b;});
    }
};

final code

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        int res = 0;
        for(const auto& num : nums)
            res ^= num;
        return res;
    }
};

位运算:

  • 如果我们对 0 和二进制位做 XOR 运算,得到的仍然是这个二进制位
    • a ⊕ 0 = a a \oplus 0 = a a0=a
  • 如果我们对相同的二进制位做 XOR 运算,返回的结果是 0
    • a ⊕ a = 0 a \oplus a = 0 aa=0
  • XOR 满足交换律和结合律
    • a ⊕ b ⊕ a = ( a ⊕ a ) ⊕ = 0 ⊕ b = b a \oplus b \oplus a = (a \oplus a) \oplus = 0\oplus b = b aba=(aa)=0b=b

直接将所有的数进行 XOR 操作,得到唯一的一个数字。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值